| Face Engine SDK 5.33.0 A face detection, recognition and tracking engine.

- Main Page
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
Classes | Public Types | Public Member Functions | List of all members
fsdk::IBestShotQualityEstimator Struct Referenceabstract
Estimators

BestShotQuality estimator interface. More...

`#include <IBestShotQualityEstimator.h>`

Inheritance diagram for fsdk::IBestShotQualityEstimator:

## Classes
struct | EstimationResult
| BestShotQualityEstimator output structure. More...

## Public Types
enum | EstimationRequest { estimateAGS = 1 << 0, estimateHeadPose = 1 << 1, estimateAll = 0xffff }
| EstimationRequest lists all possible estimation attributes that BestShotQuality estimator is able to estimate. More...
using | EstimationBatch = std::vector< EstimationResult >
| Common aliases for BestShotQuality asynchronous interface.
using | EstimationBatchFuture = vlc::future< EstimationBatch >

## Public Member Functions
virtual Result< FSDKError > | estimate (const Image &image, const Detection &detection, const EstimationRequest request, EstimationResult &result) const noexcept=0
| Estimate unified AGS and HeadPose attributes. More...
virtual Result< FSDKError > | estimate (Span< const Image > images, Span< const Detection > detections, const EstimationRequest request, Span< EstimationResult > results) const noexcept=0
| Estimate unified AGS and HeadPose attributes of multiple frames in a single estimate function call. More...
virtual EstimationBatchFuture | estimateAsync (Span< const Image > images, Span< const Detection > detections, const EstimationRequest request) const =0
| Asynchronously estimate unified AGS and HeadPose attributes of multiple frames in a single estimate function call. More...
virtual Result< FSDKError > | validate (Span< const Image > images, Span< const Detection > detections, const EstimationRequest request, Span< Result< FSDKError >> errors) const noexcept=0
| Validate input of multiple frames in a single function call. More...
Public Member Functions inherited from fsdk::IRefCounted
virtual int32_t | retain () noexcept=0
| Increase strong reference count. More...
virtual int32_t | retainLocked () noexcept=0
| Increase strong reference count thread safely. More...
virtual int32_t | release () noexcept=0
| Decrease strong reference count. More...
virtual int32_t | getRefCount () const noexcept=0
| Get actual strong reference count. More...
virtual int32_t | retainWeak () noexcept=0
| Increase weak reference count. More...
virtual int32_t | releaseWeak () noexcept=0
| Decrease weak reference count. More...
virtual int32_t | getWeakRefCount () const noexcept=0
| Get actual weak reference count. More...

## Detailed Description

BestShotQuality estimator interface.

Note
  This estimator is designed to work with Image and detection;

## Member Enumeration Documentation

enum fsdk::IBestShotQualityEstimator::EstimationRequest

EstimationRequest lists all possible estimation attributes that BestShotQuality estimator is able to estimate.

Enumerator
estimateAGS | Estimate AGS.
estimateHeadPose | Estimate HeadPose.
estimateAll | Make full estimation (all attributes)

## Member Function Documentation

virtual Result<FSDKError> fsdk::IBestShotQualityEstimator::estimate | ( | const Image & | image,
|  | const Detection & | detection,
|  | const EstimationRequest | request,
|  | EstimationResult & | result
| ) |  | const
| pure virtual noexcept

Estimate unified AGS and HeadPose attributes.

Parameters

  [in] | image | source image;
  [in] | detection | detection coordinates in image space;
  [in] | request | EstimationRequest structure;
  [out] | result | output estimation.

Returns
  Result with error code.

See Also
  IBestShotQualityEstimator::EstimationRequest, IBestShotQualityEstimator::EstimationResult, Detection, Image, Result and FSDKError for details.

Note
  image format must be R8G8B8,

See Also
  Format.

virtual Result<FSDKError> fsdk::IBestShotQualityEstimator::estimate | ( | Span< const Image > | images,
|  | Span< const Detection > | detections,
|  | const EstimationRequest | request,
|  | Span< EstimationResult > | results
| ) |  | const
| pure virtual noexcept

Estimate unified AGS and HeadPose attributes of multiple frames in a single estimate function call.

Parameters

  [in] | images | span of source images.
  [in] | detections | span of detection coordinates in corresponding source images space.
  [in] | request | EstimationRequest structure.
  [out] | results | span of estimations.

Returns
  Result with error code.

See Also
  IBestShotQualityEstimator::EstimationRequest, IBestShotQualityEstimator::EstimationResult, Span, Detection, Image, Result and FSDKError for details.

Note
  images format must be R8G8B8,

See Also
  Format.

Note
  all spans should be based on user owned continuous collections.
  all spans should be equal size.

virtual EstimationBatchFuture fsdk::IBestShotQualityEstimator::estimateAsync | ( | Span< const Image > | images,
|  | Span< const Detection > | detections,
|  | const EstimationRequest | request
| ) |  | const
| pure virtual

Asynchronously estimate unified AGS and HeadPose attributes of multiple frames in a single estimate function call.

Parameters

  [in] | images | span of source images.
  [in] | detections | span of detection coordinates in corresponding source images space.
  [in] | request | EstimationRequest structure.

Returns
  Future estimation result object.

See Also
  IBestShotQualityEstimator::EstimationRequest, IBestShotQualityEstimator::EstimationResult, Span, Detection, Image, Result, FSDKError and vlc::future for details.

Note
  images format must be R8G8B8,

See Also
  Format.

Note
  all spans should be based on user owned continuous collections.
  all spans should be equal size.
  this method is experimental and interface may be changed in the future.
  this method is not marked as noexcept and may throw an exception.

virtual Result<FSDKError> fsdk::IBestShotQualityEstimator::validate | ( | Span< const Image > | images,
|  | Span< const Detection > | detections,
|  | const EstimationRequest | request,
|  | Span< Result< FSDKError >> | errors
| ) |  | const
| pure virtual noexcept

Validate input of multiple frames in a single function call.

Parameters

  [in] | images | span of source images.
  [in] | detections | span of detection coordinates in corresponding source images space.
  [in] | request | EstimationRequest structure.
  [out] | errors | output span of errors for each image.

Returns
  Result with error code.

See Also
  IBestShotQualityEstimator::EstimationRequest, Span, Detection, Image, Result and FSDKError for details.

Note
  images format must be R8G8B8,

See Also
  Format.

Note
  all spans should be based on user owned continuous collections.
  all spans should be equal size.

The documentation for this struct was generated from the following file:

- include/fsdk/Estimators/IBestShotQualityEstimator.h